Subject: Re: bug#17537: x-window-property doesn't work for most properties

From: Jan Djärv <[email-masked]>
Date: Wed, 21 May 2014 17:42:58 +0200

Hello.

21 maj 2014 kl. 09:57 skrev Jeremy Maitin-Shepard <[email-masked]>:

> Okay.  What about making it work when specifying a frame, and building with a toolkit?  It seems there is an outer-window-id (which is the top-level window as far as the window manager and other X programs like xprop are concerned), and then there is window-id.  
> 
> While I see now that this can be worked around in elisp, shouldn't x-window-property use outer-window-id when a frame is specified, since that is almost certainly what is desired?

It sounds reasonable.  gs.el would have to be changed also.
In theory it could break other lisp code, but we don't know.
Perhaps a new lisp wrapper is better.  The doc for x-window-property could mention it.

Another alternative is that x-window-property tries outer-id if inner-id gives nothing.

	Jan D.

> 
> 
> On Wed, May 21, 2014 at 12:27 AM, Andreas Schwab <[email-masked]> wrote:
> Jeremy Maitin-Shepard <[email-masked]> writes:
> 
> > x-window-property seems to return nil for most properties.
> >
> > (x-window-property "WM_HINTS")  -> returns non-nil
> >
> > (x-window-property "WM_NAME") -> returns nil even though the property is
> > set (and displayed by xprop)
> >
> > (x-window-property "_NET_WM_STATE") -> returns nil even though property is
> > set
> >
> > In fact I haven't found any property I can read other than WM_HINTS.
> 
> You can, if you use the same window id for the target window as xprop
> (or build emacs without toolkit).
> 
> Andreas.
> 
> --
> Andreas Schwab, SUSE Labs, [email-masked]
> GPG Key fingerprint = 0196 BAD8 1CE9 1970 F4BE  1748 E4D4 88E3 0EEA B9D7
> "And now for something completely different."
>